{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckObjs {$ENDIF}, Funcs;
{$ELSE}
{$I uses.inc} mirror,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
  ;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    MainMenu1: TKOLMainMenu;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    Panel1: TKOLPanel;
    Panel2: TKOLPanel;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Panel3: TKOLPanel;
    ListBox1: TKOLListBox;
    Panel4: TKOLPanel;
    GroupBox1: TKOLGroupBox;
    Panel5: TKOLPanel;
    PaintBox1: TKOLPaintBox;
    RadioBox3: TKOLRadioBox;
    RadioBox4: TKOLRadioBox;
    KOLApplet1: TKOLApplet;
    OpenSaveDialog2: TKOLOpenSaveDialog;
    procedure KOLForm1N2Menu(Sender: PMenu; Item: Integer);
    procedure ListBox1SelChange(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure RadioBox3Click(Sender: PObj);
    procedure RadioBox4Click(Sender: PObj);
    procedure KOLForm1N5Menu(Sender: PMenu; Item: Integer);
    procedure PaintBox1Click(Sender: PObj);
    procedure KOLForm1N4Menu(Sender: PMenu; Item: Integer);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses About;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1N2Menu(Sender: PMenu; Item: Integer);
var
  i: Integer;
  SSize: string;
begin
  {***   }
  if not OpenSaveDialog1.Execute then Exit;
  Wl6Name:=OpenSaveDialog1.Filename;
  ListBox1.Clear;
  FWl6:=NewReadFileStream(Wl6Name);
  FWl6.Read(TotalFiles,2);
  Label2.Caption:=Int2Str(TotalFiles);
  SetLength(Entries,TotalFiles);
  FWl6.Seek($06,spBegin);
  for i:=0 to TotalFiles-1 do FWl6.Read(Entries[i].Offset,4);
  for i:=0 to TotalFiles-1 do FWl6.Read(Entries[i].Size,2);
  for i:=0 to TotalFiles-1 do
  begin
    case FrameType(i) of
    ftFull: SSize:='';
    ftItem: SSize:='';
    ftNone: SSize:=' ';
    end;
    ListBox1.Add('['+BuildStr(Int2Str(i),'0',3)+'] '+SSize);
  end;
  FWl6.Free;
end;

procedure TForm1.ListBox1SelChange(Sender: PObj);
var
  FTemp: PStream;
  SRect: TRect;
  DRect: Array [0..1]of TRect;
begin
  if ListBox1.CurIndex<0 then Exit;
  FWl6:=NewReadFileStream(Wl6Name);
  FTemp:=NewMemoryStream;
  SRect.Left:=0;
  SRect.Right:=63;
  SRect.Top:=0;
  SRect.Bottom:=63;
  DRect[0].Left:=0;
  DRect[0].Right:=64;
  DRect[0].Top:=0;
  DRect[0].Bottom:=64;
  DRect[1].Left:=0;
  DRect[1].Right:=128;
  DRect[1].Top:=0;
  DRect[1].Bottom:=128;
  case FrameType(ListBox1.CurIndex) of
    ftFull:begin
             GenerateImage(ftFull,FWl6,FTemp,Entries[ListBox1.CurIndex].Offset,TempBitmap);
             PaintBox1.Canvas.FillRect(DRect[1]);
             PaintBox1.Width:=DRect[Options.Zoom].Right;
             PaintBox1.Visible:=True;
             TempBitmap.LoadFromStream(FTemp);
             TempBitmap.StretchDraw(PaintBox1.Canvas.Handle,DRect[Options.Zoom]);
           end;
    ftItem:begin
             GenerateImage(ftItem,FWl6,FTemp,Entries[ListBox1.CurIndex].Offset,TempBitmap);
             PaintBox1.Canvas.FillRect(DRect[1]);
             PaintBox1.Width:=DRect[Options.Zoom].Right;
             PaintBox1.Visible:=True;
             TempBitmap.LoadFromStream(FTemp);
             TempBitmap.StretchDraw(PaintBox1.Canvas.Handle,DRect[Options.Zoom]);
            end;
    ftNone:ShowMessage('   ');
  end;
  FWl6.Free;
  {***  }
  FTemp.Free;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  BMPInit;
  PaintBox1.Visible:=False;
end;

procedure TForm1.RadioBox3Click(Sender: PObj);
begin
  Options.Zoom:=0;
end;

procedure TForm1.RadioBox4Click(Sender: PObj);
begin
  Options.Zoom:=1;
end;

procedure TForm1.KOLForm1N5Menu(Sender: PMenu; Item: Integer);
begin
  Form2.Form.ShowModal;
end;

procedure TForm1.PaintBox1Click(Sender: PObj);
begin
  OpenSaveDialog2.FileName:=CurDir+'\'+BuildStr(Int2Str(ListBox1.CurIndex),'0',3);
  if not OpenSaveDialog2.Execute then Exit;
  if Pos('.',OpenSaveDialog2.FileName)=0 then TempBitmap.SaveToFile(OpenSaveDialog1.FileName+'.bmp') else TempBitmap.SaveToFile(OpenSaveDialog2.FileName);
end;

procedure TForm1.KOLForm1N4Menu(Sender: PMenu; Item: Integer);
begin
  Form.Close;
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
var
  SRect: TRect;
  DRect: Array [0..1]of TRect;
begin
//  if not Options.Displayed then PaintBox1.Width:=15 else PaintBox1.Width:=DRect[Options.Zoom].Right;
  SRect.Left:=0;
  SRect.Right:=63;
  SRect.Top:=0;
  SRect.Bottom:=63;
  DRect[0].Left:=0;
  DRect[0].Right:=64;
  DRect[0].Top:=0;
  DRect[0].Bottom:=64;
  DRect[1].Left:=0;
  DRect[1].Right:=128;
  DRect[1].Top:=0;
  DRect[1].Bottom:=128;
  if TempBitmap.Width>0 then
  TempBitmap.StretchDraw(PaintBox1.Canvas.Handle,DRect[Options.Zoom]);
end;

end.



